## Prerequisites
1.	[Software Development and Maintenance](https://en.wikibooks.org/wiki/Introduction_to_Software_Engineering/Implementation/Documentation)
2.	[Git](https://linkedin.github.io/school-of-sre/level101/git/git-basics/)
3.	[Docker](https://linkedin.github.io/school-of-sre/level102/containerization_and_orchestration/containerization_with_docker/)

## What to expect from this course?
In this course, you will learn the basics of CI/CD and how it helps drive the SRE discipline in an organization. It also discusses the various DevOps tools in CI/CD practice and a hands-on lab session on [Jenkins](https://www.jenkins.io/) based pipeline. Finally, it will conclude by explaining the role in the growing SRE philosophy.

## What is not covered under this course?
The course does not cover DevOps elements such as Infrastructure as a code, continuous monitoring applications and infrastructure comprehensively.

## Table of Contents

* [What is CI/CD?](https://linkedin.github.io/school-of-sre/level102/continuous_integration_and_continuous_delivery/introduction_to_cicd)
* [Brief History to CI/CD and DevOps](https://linkedin.github.io/school-of-sre/level102/continuous_integration_and_continuous_delivery/cicd_brief_history)
* [Continuous Integration](https://linkedin.github.io/school-of-sre/level102/continuous_integration_and_continuous_delivery/continuous_integration_build_pipeline)
* [Continuous Delivery and Deployment](https://linkedin.github.io/school-of-sre/level102/continuous_integration_and_continuous_delivery/continuous_delivery_release_pipeline)
* [Jenkins based CI/CD pipeline - Hands-on](https://linkedin.github.io/school-of-sre/level102/continuous_integration_and_continuous_delivery/jenkins_cicd_pipeline_hands_on_lab)
* [Conclusion](https://linkedin.github.io/school-of-sre/level102/continuous_integration_and_continuous_delivery/conclusion)
