# System Calls and Signals

## Prerequisites

- [Linux Basics](https://linkedin.github.io/school-of-sre/level101/linux_basics/intro/)
- [Python Basics](https://linkedin.github.io/school-of-sre/level101/python_web/intro/)

## What to expect from this course

The course covers a fundamental understanding of signals and system calls. It sheds light on how the knowledge of signals and system calls can be helpful for an SRE. 

## What is not covered under this course

The course does not discuss any other interrupts or interrupt handling apart from signals. The course will not deep dive into signal handler and GNU C library. 

## Course Contents
- [Signals](https://linkedin.github.io/school-of-sre/level102/system_calls_and_signals/signals)
    - [Introduction to interrupts and signals](https://linkedin.github.io/school-of-sre/level102/system_calls_and_signals/signals/#introduction-to-interrupts-and-signals)
    - [Types of signals](https://linkedin.github.io/school-of-sre/level102/system_calls_and_signals/signals/#types-of-signals)
    - [Sending signals to process](https://linkedin.github.io/school-of-sre/level102/system_calls_and_signals/signals/#sending-signals-to-process)
    - [Handling signals](https://linkedin.github.io/school-of-sre/level102/system_calls_and_signals/signals/#handling-signals)
    - [Role of signals in system calls with the example of *wait()*](https://linkedin.github.io/school-of-sre/level102/system_calls_and_signals/signals/#role-of-signals-in-system-calls-with-the-example-of-wait)
- [System calls](https://linkedin.github.io/school-of-sre/level102/system_calls_and_signals/system_calls)
    - [Introduction](https://linkedin.github.io/school-of-sre/level102/system_calls_and_signals/system_calls/#introduction)
    - [Types of system calls](https://linkedin.github.io/school-of-sre/level102/system_calls_and_signals/system_calls/#types-of-system-calls)
    - [User mode,kernel mode and their transitions](https://linkedin.github.io/school-of-sre/level102/system_calls_and_signals/system_calls/#user-mode-kernel-mode-and-their-transitions)
    - [Working of *write()* system call](https://linkedin.github.io/school-of-sre/level102/system_calls_and_signals/system_calls/#working-of-write-system-call)
    - [Debugging in Linux with strace](https://linkedin.github.io/school-of-sre/level102/system_calls_and_signals/system_calls/#debugging-in-linux-with-strace)
    
